#!/usr/bin/env bash
g=1
bdim=2
mdim=2
for model in lstm gru o2rnn mirnn
do
    for seed in 4240 1136 8204 6264 8634 1646 3199 6735 3933 1470
    do
        for nbin in 0 1
        do
            for es in 0.85
            do
                sdim=$((bdim*mdim))
                echo "======================================================================="
                echo "model : ${model} seed : ${seed} state_dim : ${sdim} test bin : ${nbin}"
                echo "======================================================================="

                python test_lstar_dfa.py \
                    --suffix "tomita_g${g}_sdim_${sdim}_es_${es}_bce" \
                    --dfa_path "../lstar_dfa/dfa_lstar_rnn_${model}_g${g}_sdim_${sdim}_es_${es}_seed_${seed}.dfa" \
                    --seed $seed \
                    --state_dim $sdim\
                    --model "rnn" \
                    --rnn_cell $model \
                    --mtype "classification" \
                    --grammar "tomita-${g}"\
                    --dtype "test" \
                    --nbin $nbin \
                    --dataset "MSI" \
                    --result_file "../results/lstar_dfa_${es}/g${g}_${model}_sdim_${sdim}_es_${es}_nbin_${nbin}.json" \
                    --remove_start \
                    --remove_end
            done
        done 
    done
done
